﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace addedRowBugReproduced
{
    public class Student : INotifyPropertyChanging, INotifyPropertyChanged
    {
        string first_name;
        public string First_name
        {
            get { return first_name; }
            set 
            {
                if (first_name != value)
                {
                    SendPropertyChanging("First_name");
                    first_name = value;
                    SendPropertyChanged("First_name");
                }
            }
        }

        string last_name;
        public string Last_name
        {
            get { return last_name; }
            set 
            {
                if (last_name != value)
                {
                    SendPropertyChanging("Last_name");
                    last_name = value;
                    SendPropertyChanged("Last_name");
                }
            }
        }

        int grade;
        public int Grade
        {
            get { return grade; }
            set 
            {
                if (grade != value)
                {
                    SendPropertyChanging("Grade");
                    grade = value;
                    SendPropertyChanged("Grade");
                }
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        #region INotifyPropertyChanging Members

        public event PropertyChangingEventHandler PropertyChanging;

        #endregion

        void SendPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        void SendPropertyChanging(string propertyName)
        {
            if (PropertyChanging != null)
            {
                PropertyChanging(this, new PropertyChangingEventArgs(propertyName));
            }
        }
    }
}
